REBOL []

install-HTTPd-extension [
	name: 'mod-alias
	
	order: [
		url-to-filename	first
	]
	
	aliases: [
		location [
			file []
			path []
		]
		folder [
			file []
			path []
		]
	]
	
	redirects: make block! 10
	
	url-to-filename: func [req /local list pattern action url][
		; --- Test matching virtual host		
		if list: select redirects req/vhost [
			; -- Test matching patterns on request path	
			url: join req/in/path req/in/target			
			foreach [pattern action] list [		
				if find/any/match url pattern [			
					req/out/code: second action
					if slash = last url: first action [
						insert tail url: copy url join req/in/target any [req/in/arg ""]
					]				
					h-store req/out/headers 'Location url
					return true
				]
			]
		]
		false
	]
	
	words: [
		;--- make location and folder aliases
		alias: [word!] [string! | file!] 'to [string! | file!] in main do [
			use [store][
				store: pick [folder location] file? args/2
				type: args/1
				repend service/mod-list/mod-alias/aliases/:store/:type [
					args/2 args/3
				]
			]
		]
		redirect: [integer!] [string!] [string!] in main do [	
			use [list pos][
				list: service/mod-list/mod-alias/redirects
				if not pos: select list vhost [
					repend list [vhost pos: copy []]
				]
				repend pos [args/2 reduce [args/3 args/1]]
			]
		]
	]
]